//================================================================
//MARK: Class Tendril
//================================================================

class Tendril {

  //-------------------------------------------------
  //Properties
  //-------------------------------------------------
  float len, phase;
  Side side;

  PVector anchor;
  PVector cp0, cp1;
  color col;

  private color originalColor;

  Tendril(float _length, float _phase, Side _side) {
    len = _length;
    phase = _phase;
    side = _side;

    float cpx0 = random(len * 0.5) + len * 0.1;
    float cpy0 = random(len * 0.4) - len * 0.2;
    cp0 = new PVector(cpx0, cpy0);

    float cpx1 = random(len * 0.3) + len * 0.4;
    float cpy1 = random(len * 0.4) - len * 0.2;
    cp1 = new PVector(cpx1, cpy1);

    anchor = new PVector(-1, -1);
  }

  void setColor(color c) {
    float hue, sat, bri;
    hue = hue(c);
    sat = saturation(c);
    bri = int(random(brightness(c) - 55) + 55);
    col = color(hue, sat, bri);
    originalColor = col;
  }

  void setColorSaturation(float s) {
    col = color(hue(originalColor), s, brightness(originalColor));
  }

  void setColorBrightness(float b) {
    col = color(hue(originalColor), saturation(originalColor), b);
  }
}